FUNCTION -
    THE ASSEMBLER PROMPTER FACILITATES TO INVOKE THE ASSEMBLER UNDER
    TSS ENVIRONMENTS.

 SYNTAX -
    ASM 'DSNAME' ALIGN/NOALIGN  ALOGIC/NOALOGIC  BATCH/NOBATCH
                 BUFSIZE(STD/MIN)  ESD/NOESD  FLAG('INTEGER')
                 LIB('DSNAME LIST')  LIBDD/LIBDD('DDNAME')/NOLIBDD
                 LIBMAC/NOLIBMAC  LINECOUNT('INTEGER')
                 LIST/LIST('DSNAME'/*)/NOLIST  MACLIB/NOMACLIB
                 MCALL/NOMCALL  MLOGIC/NOMLOGIC  NAME/NONAME
                 NUMBER/NONUMBER  OBJECT/OBJECT('DSNAME')/NOOBJECT
                 RENT/NORENT  RLD/NORLD  STMT/NOSTMT  SYSPARM('STRING')
                 SYSPRINT/SYSPRINT('CLASS')/
                               PRINT/PRINT('DSNAME'/*)/NOPRINT
                 TERMINAL/NOTERMINAL  TEST/TEST(FULL/SHORT)/NOTEST
                 XREF/XREF(FULL/SHORT)/NOXREF
    NOTE- LC('INTEGER') CAN BE USED FOR LINECOUNT('INTEGER')
    REQUIRED- 'DSNAME'
    DEFAULTS- ALIGN     ALOGIC    NOBATCH   BUFSIZE(STD)        NOESD
              FLAG(0)   NOLIBDD   NOLIBMAC  LINECOUNT(54)       NOLIST
              MACLIB    NOMCALL   NOMLOGIC  NONAME    NUMBER    OBJECT
              PRINT     NORENT    NORLD     STMT      SYSPARM('')
 ***
             TERMINAL  NOTEST    NOXREF
      ::: SUB-FIELD  LIBDD(ASMSLIB) TEST(FULL) XREF(FULL) SYSPRINT(A)

 OPERANDS -
   'DSNAME' IS A LIST OF DATA SET NAME ASSIGNED TO THE ASSEMBLER
     SOURCE DATA SET.
   ALIGN   SPECIFIES THAT ALL DATA IN THE OBJECT MODULE IS ALIGNED
     ON THE BOUNDARY.
   NOALIGN   SPECIFIES THAT DATA AREAS OTHER THAN THOSE SPECIFIED IN
     CCW INSTRUCTIONS ARE NOT ALIGNED.
   ALOGIC   SPECIFIES THAT CONDITIONAL ASSEMBLY STATEMENTS PROCESSED
     IN OPEN CODE ARE PRINTED IN THE ASSEMBLY LISTING.
   NOALOGIC   SPECIFIES THAT NO CONDITIONAL ASSEMBLY STATEMENTS IN OPEN
     CODE ARE PRINTED.
   BATCH   ALLOWS MULTIPLE INVOCATION OF ASSEMBLER. EACH ASSEMBLY
     UNIT ARE SEPARATED BY END STATEMENT.
   NOBATCH   SPECIFIES THAT NO MULTIPLE ASSEMBLY TO BE INVOKED.
   BUFSIZE(STD)   SPECIFIES THAT OPTIMIZED BUFFER SIZE IS USED FOR EACH
     WORK DATA SETS.
   BUFSIZE(MIN)   SPECIFIES THAT MINIMUM BUFFER SIZE IS USED FOR EACH
     WORK DATA SETS.
   ESD   SPECIFIES THAT THE EXTERNAL SYMBOL DICTIONARY IS PRINTED AS A
     PART OF ASSEMBLY LISTING.
  NOESD   SPECIFIED THAT NO EXTERNAL SYMBOL DICTIONARY IS PRINTED.
   FLAG('INTEGER')   SPECIFIES THAT DIAGNOSTIC MESSAGES AND MNOTE
     MESSAGES BELOW 'INTEGER' WILL NOT APPEAR IN LISTING.
   LIB('DSNAME LIST')   SPECIFIES A NAME LIST OF LIBRARY DATA SETS TO
     BE USED IN ASSEMBLY. IF OTHER LIBRARY OPTIONS (LIBDD,MACLIB) ARE
     IN EFFECT, EACH LIBRARY IS CONCATINATED IN FOLLOWING ORDER.
          LIB('DSNAME LIST'):LIBDD('DDNAME'):MACLIB
   LIBDD('DDNAME')   SPECIFIES THAT LIBRARY SPECIFIED IN DD NAME
     IS USED. IF ('DDNAME') IS OMITTED, THE DEFAULT DD NAME IS USED. IF
     OTHER LIBRARY OPTIONS (LIB,MACLIB) ARE IN EFFECT, EACH LIBRARY ARE
     CONCATINATED IN FOLLOWING ORDER.
          LIB('DSNAME LIST'):LIBDD('DDNAME'):MACLIB
   NOLIBDD   SPECIFIES THAT LIBRARY SPECIFIED IN DD NAME IS NOT USED.
   LIBMAC   SPECIFIES THAT LIBRARY MACRO DEFINITIONS USED IN ASSEMBLY
     AND ANY ASSEMBLER STATEMENTS FOLLOWING THE LOGICAL END STATEMENT
     ARE PRINTED AFTER LOGICAL END STATEMENT.
   NOLIBMAC   SPECIFIES THAT NO LIBRARY MACRO DEFINITIONS AND NO
     ASSEMBLER STATEMENTS FOLLOWING THE LOGICAL END STATEMENT ARE
     PRINTED.
   LINECOUNT('INTEGER')   SPECIFIES THE NUMBER OF LINES TO BE PRINTED
     BETWEEN HEADING.
   LIST('DSNAME'/*) OR LIST   SPECIFIES THAT ASSEMBLY LISTING IS
     PRODUCED AND PLACED IN THE DATA SET SPECIFIED BY ('DSNAME')
    OR (*). HERE, * MEANS TO PLACE THE LISTING TO TERMINAL.
     IF ('DSNAME') IS NOT SPECIFIED NOR (*), THE STANDERD DATA SET
     IS USED.
   NOLIST   SPECIFIES THAT NO ASSEMBLY LISTING IS PRODUCED.
   MACLIB   SPECIFIES THAT SYSTEM STANDARD LIBRARY SYS1.MACLIB IS USED.
     IF OTHER LIBRARY OPTIONS (LIBDD,LIB) ARE IN EFFECT, EACH LIBRARY
     ARE CONCATINATED IN FOLLOWING ORDER.
          LIB('DSNAME LIST'):LIBDD('DDNAME'):MACLIB
   NOMACLIB   SPECIFIES THAT SYSTEM STANDARD LIBRARY DATA SET
     SYS1.MACLIB IS NOT USED.
   MCALL   SPECIFIES THAT INNER MACRO INSTRUCTIONS ENCOUNTERED DURING
     MACRO GENERATION ARE PRINTED FOLLOWING THEIR RESPECTIVE OUTER MACRO
     INSTRUCTIONS. THE MCALL OPTION IS IMPLIED BY THE MLOGIC OPTION.
   NOMCALL   SPECIFIES THAT NO INNER MACRO INSTRUCTIONS ARE PRINTED. IF
     MLOGIC IS IN EFFECT, NOMCALL HAS NO EFFECT.
   MLOGIC   SPECIFIES THAT ALL MACRO DEFINITION STATEMENTS PROCESSED
     DURING MACRO GENERATION ARE PRINTED AFTER THE MACRO INSTRUCTION.
   NOMLOGIC   SPECIFIES THAT NO MACRO DEFINITION STATEMENTS PROCESSED
     ARE PRINTED.
   NAME   SPECIFIES THAT NAME RECORD IS PRODUCED AT END OF THE OBJECT
     MODULE. THAT RECORD IS USED BY LINKAGE EDITOR.
   NONAME   SPECIFIES THAT NO NAME RECORD IS PRODUCED.
   NUMBER   SPECIFIES THAT ID FIELD, COL.73-80, OF THE ERROR STATEMENT
    APPEARS ON THE SYSTERM LISTING.
   NONUMBER   SPECIFIES THAT ID FIELD, COL.73-80, OF THE ERROR STATEMENT
     IS DELETED FROM SYSTERM LISTING.
   OBJECT('DSNAME') OR OBJECT   SPECIFIES THAT OBJECT MODULE IS PRODUCED
     IN THE DATA SET SPECIFIED BY 'DSNAME'. IF ('DSNAME') IS NOT PRESENT
     THE STANDARD DATA SET IS USED.
   NOOBJECT   SPECIFIES THAT NO OBJECT MODULE IS PRODUCED.
   PRINT('DSNAME'/*) OR PRINT   SPECIFIES THAT ASSEMBLY LISTING IS
     WRITTEN IN THE DATA SET SPECIFIED BY ('DSNAME') OR (*). HERE, *
     MEANS TO WRITE THE LISTING ON TERMINAL. IF ('DSNAME') IS NOT
     SPECIFIED NOR (*), THE STANDARD DATA SET IS USED.
   SYSPRINT('SYSOUT CLASS') OR SYSPRINT   SPECIFIES THAT ASSEMBLY
     LISTING IS PRINTED THROUGH OUT THE SPECIFIED SYSOUT CLASS.
     IF SYSOUT CLASS IS OMITTED, THE DEFAULT CLASS IS USED.
   NOPRINT   SPECIFIES THAT NO ASSEMBLY LISTING IS WRITTEN.
   RENT   SPECIFIES TO CHECK FOR RE-ENTRABILITY.
   NORENT   SPECIFIES THAT NO CHECK IS MADE FOR RE-ENTRABILITY.
   RLD   SPECIFIES THAT THE RELOCATION DICTIONARY IS PRINTED AS A PART
     OF ASSEMBLY LISTING.
   NORLD   SPECIFIES THAT NO RELOCATION DICTIONARY IS PRINTED.
   STMT   SPECIFIES THAT THE STATEMENT NUMBER ASSIGNED BY ASSEMBLER IS
     WRITTEN ON THE TERMINAL FOR THE ERROR STATEMENT.
   NOSTMT   SPECIFIES THAT NO STATEMENT NUMBER IS WRITTEN ON THE
    TERMINAL FOR THE ERROR STATEMENT.
   SYSPARM('STRING')   SPECIFIES A CHARACTER STRING TO BE PASSED TO
     SYSTEM VARIABLE SYMBOL &SYSPARM. MAXIMUM 255 CHARACTERS ALLOW.
   TERMINAL   SPECIFIES THAT DIAGNOSTIC INFORMATION AND ERROR STATEMENTS
     ARE WRITTEN OUT TO THE TERMINAL.
   NOTERMINAL   SPECIFIES THAT NO DIAGNOSTIC INFORMATION AND NO ERROR
     STATEMENT ARE WRITTEN OUT TO THE TERMINAL.
   TEST(FULL/SHORT) OR TEST   SPECIFIES THAT SOURCE SYMBOL TABLE IS
     PRODUCED IN THE OBJECT MODULE. THAT TABLE IS USED BY TEST COMMAND.
     TABLE ENTRY IS MAKED FOR ALL SYMBOL AND DC,DS INSTRACTIONS, IF YOU
     SPECIFY TYPE FULL. TO DELETE ENTRY FOR SYMBOL WITHIN DSECT,
     SPECIFY TYPE SHORT. IF TYPE IS OMITTED, DEFAULT TYPE IS USED.
   NOTEST   SPECIFIES THAT NO SOURCE SYMBOL TABLE IS PRODUCED.
   XREF(FULL/SHORT) OR XREF   SPECIFIES THAT CROSS-REFERENCE TABLE OF
     SYMBOLS IS PRINTED AS A PART OF ASSEMBLY LISTING. CROSS-REFERENCE
     TABLE OF ALL SYMBOL IS PRODUCED IF YOU SPECIFY TYPE FULL, TO DELETE
     NON REFERENCED SYMBOL, SPECIFY TYPE SHORT. IF TYPE IS OMITTED, THE
     DEFAULT TYPE IS USED.
   NOXREF   SPECIFIES THAT NO CROSS-REFERENCE TABLE IS PRINTED.
:
