%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:SYSTEM-DATE.SL
% Description:  Date and time routines.
%               (Partly taken from VAX version of date.)
% Author:       RAM, HP/FSD
% Created:      27-Feb-84
% Modified:     17-Jul-84 22:56:41 (RAM)
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 17-Jul-84 22:52:31 (RAM)
%  Changed allocation of datebuffer from warray declaration to a call on
%  gtwarray (the compiler was emitting bad code for declare-warray on
%  non-kernel modules).
%  Changed call of function time to a call of function external_time.
%  Time is defined in top-loop.sl, and was conflicting, now that this time
%  is not flagged as a foreignfunction.
%  Removed many prog nil constructs and reformatted comments.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(fluid '(datebuffer))
(setq datebuffer (gtwarray 1))

(de date-and-time ()                    % current date, as "12-Sep-55 13:35:22"
  (external_time datebuffer)            % get the current time
  (datebuffer-to-string))

(de date-int-to-string (dateint)        % convert date, as "12-Sep-55 13:35:22"
  (setf (wgetv datebuffer 0) dateint)   % put time in datebuffer
  (datebuffer-to-string))

(de datebuffer-to-string ()             % convert date, as "12-Sep-55 13:35:22"
   (ctime))

(fluid '(tokenbuffer*))

(setq tokenbuffer* (gtwarray 10))

(de ctime ()
  (prog (a1 a2 a3 a4 a5 a6 s tb)
    (setq a1 (wand 255 (getdat onewordbuffer)))
    (setq a2 (wgetv  onewordbuffer 0))
    (setq a3 (wgetv  onewordbuffer 1))
    (gettime onewordbuffer)
    (setq a4 (wand 255(wshift (wgetv  onewordbuffer 0) -8)))
    (setq a5 (wand 255 (wgetv  onewordbuffer 0)))
    (setq a6  (wand 255(wshift (wgetv  onewordbuffer 1) -8)))
    (setq tb tokenbuffer)
    (setq tokenbuffer tokenbuffer*)
    (setq s (bldmsg "%w %w-%w-%w %w:%w:%w"
                     (getv '["Sun" "Mon" "Tue" "Wed" "Thu" "Fri" "Sat"] a1)
                     (wand a3 255) (wand (wshift a3 -8) 255)
                     (wand 16#ffff a2) a4 a5 a6))
    (setq tokenbuffer tb)
    (return s) ))

