%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File:  fast-link.sl -  fast link for Cray Psl
%
% Author: H. Melenk , ZIB Berlin
%         W. Neun
%
% Date : 10-Sep-86
%
% Copyright (c) 1987, Konrad Zuse-Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% W. Neun , ZIB Berlin, 11 August 1988
%     Fixed lengths of instructions for Y-MP machines
 
(compiletime (load if-system fast-vector hash-decls inum))
 
(compiletime (flag '(internalentries ) 'internalfunction))
 
(compiletime (setq *syslisp t))
 
(fluid '(*system-is-fast-linked*))
 
% fast-link a function.
% replace symfnc jumps by direct jumps to called functions via the
% contents of the symfnc location.
% dont do this if function is undefined or interpreted.
% end of function is defined either by a zero parcel or the address
% of the first "mkid" word lying in code below entry
 
(de fast-link1 (fkt)
   (prog(base instr i j k jk p1 p2 lth jumpinst jumpaddr jumpaddr4
         oldbase not-a-symfnc-jump
         mem jmem jmem4 symfnchigh fkthigh mem4 wbase)
 
         (setq symfnchigh (wplus2 symfnc maxsymbols))
         (setq fkthigh nextbps)            % safe endcondition
 
       (if (numberp fkt) (progn
                         (setq base fkt)
                         (when (or (wgeq (wrshift base 2) nextbps)
                                   (wleq (wrshift base 2) bps))
                               (return nil)))
        (progn
         (when (or (not (idp fkt)) (funboundp fkt)) (return nil))
         (when (flambdalinkp fkt) (return nil))
         (setq base (getmem (wplus2 symfnc (id2int fkt))))
         (setq base (wand 16#3FFFFF (wrshift base 32)))))
 
         (setq wbase (wrshift base 2))
         (setq oldbase base)
 
loop1
         (setq p1 (CrayGetParcel base))
         (cond((eq p1 0)                %end condition
             (return (internalentries base oldbase not-a-symfnc-jump)))
              ((wgeq (wrshift base 2) fkthigh)
             (return (internalentries base oldbase not-a-symfnc-jump))))
         (setq instr (wrshift p1 9))      % instruction
     (if_system Y-MP  % 3-parcel instructions
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#017)) 2)
             ((and (wgeq instr 8#020)(wleq instr 8#021)) 3)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 3)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 3)
             (t 1) ))
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#021)) 2)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 2)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 2)
             (t 1) )))
         (setq i (wand  8#7 (wrshift p1 6)))
         (setq j (wand  8#7 (wrshift p1 3)))
         (setq k (wand  8#7 p1))
         (when (eq lth 2)
           (setq p2 (CrayGetParcel (wplus2 base 1)))
           (setq mem (wplus2 p2
                      (wlshift
                        (wplus2 k
                          (wlshift j 3)
                        ) 16
           )         ))
           (setq jmem (wplus2  mem (wlshift i 22))) % a jump address
         )
         (cond
               ((and (wgeq instr 8#100) (wleq instr 8#107)) (go load))
               ((and (wgeq instr 8#120) (wleq instr 8#127)) (go load))
               ((and (wgeq instr 8#006) (wleq instr 8#017)) (go jump))
               (t (go next) ))
 load
         (cond ((and (wgreaterp mem wbase)
                     (wlessp mem fkthigh)) (setq fkthigh mem))
         )
         (go next)
 
 jump    (setq jmem4 (wrshift jmem 2))
         (cond ((and (wgeq jmem4 symfnc)
                     (wleq jmem4 symfnchigh))
                      (progn
                        (setq jumpinst (getmem jmem4))
                        (setq jumpaddr
                               (wand 16#3FFFFF (wrshift jumpinst 32)))
                        (setq jumpaddr4 (wrshift jumpaddr 2))
                        (when (or
                            (eq jumpaddr4 undefined-function-address)
                            (eq jumpaddr4 lambda-link-address))
                                  (go next))
                        (crayputparcel (wplus2 base 1)
                                   (wand jumpaddr 16#ffff))
                        (setq jumpaddr (wrshift jumpaddr 16))
                        (crayputparcel base
                                   (wor jumpaddr (wlshift instr 9)))
                      ))
               (t (setq not-a-symfnc-jump
                    (cons jmem not-a-symfnc-jump))))
 next    (setq base (wplus2 base lth))
         (go loop1)
))
 
(de internalentries (base oldbase list)
     (cond ((atom list) nil)                                            %%%%%%%%
           ((and(wgeq (car list) oldbase)
                (wleq (car list) base)) (internalentries base oldbase
                                          (cdr list)))
           (t (cons (car list) (internalentries base oldbase (cdr list)
              )                ))))
 
(de plantunbound (a) (putmem (wplus2 symfnc (inf a)) 0)
                  (plantcodepointer a undefined-function-address 0))
 
(de plantlambdalink (atom bits)
                  (plantcodepointer atom lambda-link-address bits))
 
(lap '((*entry plantcodepointer expr 3)
       (*alloc 0)
       (*move (reg 3) (reg 5))  % construct a jump and symfnc-extra
       (*move 6 (reg 4))
       (lshift (reg 4) (reg 4) 57)
       (*wor (reg 5) (reg 4))
       (*move (reg 1) (reg a6))
       (*move ($fluid symfnc) (reg a7)) % compute address
       (*wplus2 (reg a6) (reg a7))
       (load (reg 3) 0 (reg a6))        % old symfnc entry
       (*move (reg a6) (reg 4))
       (*move (reg 4) (reg 1))          % symfnc address
       (lshift (reg 2) (reg 2) (wconst 34))
       (lshift (reg 1) (reg 1) (wconst 34))
       (*wor (reg 2) (reg 5))
       (*wor (reg 1) (reg 5))
       (lshift (reg 3) (reg 3) 7)
       (rshift (reg 3) (reg 3) 41)    % 34 plus 7
       (*jumpeq (label oje) (reg 3) (quote 0))
       (*jumpeq (label oje) (reg 3)($fluid undefined-function-address))
       (*jumpeq (label oje) (reg 3)($fluid lambda-link-address))
       (*move (reg 3) (reg a6))
       (store (reg 1) 0 (reg a6))
   oje
       (*move (reg 4) (reg a6))
       (store (reg 2) 0 (reg a6))
       (*move 0 (reg 1))
       (*exit 0)
)     )
 
(de fast-link()
    (prog (name collected-internals)
       (setq *system-is-fast-linked* t)
       (ifor (from i 0 128 1)
             (do (fast-link1 (mkid i))))
       (ifor (from i 0 hash-table-size 1)
             (do (when (occupied-slot? i)
                       (setq name (mkid (hash-table-entry i)))
                       (when
                         (not
                           (or
                             (eq name 'fast-link)
                             (eq name 'internalentries)
                             (eq name 'union)
                             (eq name 'fast-link1) ))
                         (setq collected-internals
                         (union (fast-link1 name)
                               collected-internals))))))
       (foreach x in collected-internals
              do (fast-link1 x))          ))
